#include "bnum.h"

// sum numbers
int bnum_add ( struct bignum *res, struct bignum *a, struct bignum *b)
{
	int compare = bnum_abs_cmp ( a,b);
	struct bignum *pa = ( compare != -1) ? a : b;					//|pa| always > |pb|
	struct bignum *pb = ( compare != -1) ? b : a;
	
	
	int val_size;
	int i = 0;
	short int tail = 0;
	
	res->sign = pa->sign;
	res->nalloc = pa->nalloc;
	val_size = sizeof ( unsigned short) * ( pa->top + 1);				//reserve mem for number
	res->val = realloc ( res->val, val_size);
	res->top = pa->top;
	
	if ( ( pa->sign + pb->sign) % 2 == 0) {				//if (a->sign,b-sign) (+,+) or (-,-)
		
		if (res->val == NULL) {
			fprintf ( stderr, "bnum_add realloc: %s\n", strerror(errno));
			return 1;
		}
		
		for ( i = 0; i <= pb->top; i++) {
			res->val[i] = ( tail + pa->val[i] + pb->val[i]) % BASE;				// sum pa, pb and tail
			tail = ( tail + pa->val[i] + pb->val[i]) / BASE;	
		}
		for ( i; i <= pa->top; i++ ) {							/*&& pa->top != pb->top*/	
			res->val[i] = ( tail + pa->val[i]) % BASE;					// add high part of pa 
			tail = ( tail + pa->val[i]) / BASE;	
		}
		
		if ( tail != 0) {
			res->nalloc++;
			res->val = realloc ( res->val, res->nalloc);
			if ( res->val == NULL) {
				fprintf ( stderr, "bnum_add realloc: %s\n", strerror(errno));
				return 1;
			}
			res->val[i] = tail;
			res->top++;
		}
	}
	else {									//if (a->sign,b-sign) == (+,-) or (-,+)
		for ( i=0; i<= pb->top; i++) {
			res->val[i] = ( pa->val[i] - pb->val[i] - tail);
			tail = ( pa->val[i] > pb->val[i] - tail) ? 0 :1;
		}
		for ( i; i<= pa->top; i++) {
			res->val[i] = ( pa->val[i] - tail);
			tail = ( pa->val[i] > tail) ? 0 :1;
		}
		if ( pa->val[i-1] == 0) {
			res->nalloc--;
			res->val = realloc ( res->val, res->nalloc);
			if ( res->val == NULL) {
				fprintf ( stderr, "bnum_add realloc: %s\n", strerror(errno));
				return 1;
			}
			res->top--;
		}
		
	}
	return 0;
}